## nlohmann-json3 3.6.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

##
## PROJECT
## name and version
##
project(nlohmann_json VERSION 3.6.1 LANGUAGES CXX)

##
## INCLUDE
##
##
include(ExternalProject)

##
## OPTIONS
##
option(JSON_BuildTests "Build the unit tests when BUILD_TESTING is enabled." ON)
option(JSON_Install "Install CMake targets during install step." ON)
option(JSON_MultipleHeaders "Use non-amalgamated version of the library." OFF)

##
## CONFIGURATION
##
set(NLOHMANN_JSON_TARGET_NAME               ${PROJECT_NAME})
set(NLOHMANN_JSON_CONFIG_INSTALL_DIR        "lib/cmake/${PROJECT_NAME}"
  CACHE INTERNAL "")
set(NLOHMANN_JSON_INCLUDE_INSTALL_DIR       "include")
set(NLOHMANN_JSON_TARGETS_EXPORT_NAME       "${PROJECT_NAME}Targets")
set(NLOHMANN_JSON_CMAKE_CONFIG_TEMPLATE     "cmake/config.cmake.in")
set(NLOHMANN_JSON_CMAKE_CONFIG_DIR          "${CMAKE_CURRENT_BINARY_DIR}")
set(NLOHMANN_JSON_CMAKE_VERSION_CONFIG_FILE "${NLOHMANN_JSON_CMAKE_CONFIG_DIR}/${PROJECT_NAME}ConfigVersion.cmake")
set(NLOHMANN_JSON_CMAKE_PROJECT_CONFIG_FILE "${NLOHMANN_JSON_CMAKE_CONFIG_DIR}/${PROJECT_NAME}Config.cmake")
set(NLOHMANN_JSON_CMAKE_PROJECT_TARGETS_FILE "${NLOHMANN_JSON_CMAKE_CONFIG_DIR}/${PROJECT_NAME}Targets.cmake")

if (JSON_MultipleHeaders)
    set(NLOHMANN_JSON_INCLUDE_BUILD_DIR "${PROJECT_SOURCE_DIR}/include/")
    message(STATUS "Using the multi-header code from ${NLOHMANN_JSON_INCLUDE_BUILD_DIR}")
else()
    set(NLOHMANN_JSON_INCLUDE_BUILD_DIR "${PROJECT_SOURCE_DIR}/single_include/")
    message(STATUS "Using the single-header code from ${NLOHMANN_JSON_INCLUDE_BUILD_DIR}")
endif()

##
## TARGET
## create target and add include path
##
add_library(${NLOHMANN_JSON_TARGET_NAME} INTERFACE)
add_library(${PROJECT_NAME}::${NLOHMANN_JSON_TARGET_NAME} ALIAS ${NLOHMANN_JSON_TARGET_NAME})
if (${CMAKE_VERSION} VERSION_LESS "3.8.0") 
    target_compile_features(${NLOHMANN_JSON_TARGET_NAME} INTERFACE cxx_range_for)
else()
    target_compile_features(${NLOHMANN_JSON_TARGET_NAME} INTERFACE cxx_std_11)
endif()

target_include_directories(
    ${NLOHMANN_JSON_TARGET_NAME}
    INTERFACE
    $<BUILD_INTERFACE:${NLOHMANN_JSON_INCLUDE_BUILD_DIR}>
    $<INSTALL_INTERFACE:include>
)

## add debug view definition file for msvc (natvis)
if (MSVC)
    set(NLOHMANN_ADD_NATVIS TRUE)
    set(NLOHMANN_NATVIS_FILE "nlohmann_json.natvis")
    target_sources(
        ${NLOHMANN_JSON_TARGET_NAME}
        INTERFACE
            $<INSTALL_INTERFACE:${NLOHMANN_NATVIS_FILE}>
            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/${NLOHMANN_NATVIS_FILE}>
    )
endif()

##
## TESTS
## create and configure the unit test target
##
include(CTest) #adds option BUILD_TESTING (default ON)

if(BUILD_TESTING AND JSON_BuildTests)
    enable_testing()
    add_subdirectory(test)
endif()

##
## INSTALL
## install header files, generate and install cmake config files for find_package()
##
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${NLOHMANN_JSON_CMAKE_VERSION_CONFIG_FILE} COMPATIBILITY SameMajorVersion
)
configure_file(
    ${NLOHMANN_JSON_CMAKE_CONFIG_TEMPLATE}
    ${NLOHMANN_JSON_CMAKE_PROJECT_CONFIG_FILE}
    @ONLY
)

if(JSON_Install)
    install(
        DIRECTORY ${NLOHMANN_JSON_INCLUDE_BUILD_DIR}
        DESTINATION ${NLOHMANN_JSON_INCLUDE_INSTALL_DIR}
    )
    install(
        FILES ${NLOHMANN_JSON_CMAKE_PROJECT_CONFIG_FILE} ${NLOHMANN_JSON_CMAKE_VERSION_CONFIG_FILE}
        DESTINATION ${NLOHMANN_JSON_CONFIG_INSTALL_DIR}
    )
    if (NLOHMANN_ADD_NATVIS)
        install(
            FILES ${NLOHMANN_NATVIS_FILE}
            DESTINATION .
    )
    endif()
    export(
        TARGETS ${NLOHMANN_JSON_TARGET_NAME}
        NAMESPACE ${PROJECT_NAME}::
        FILE ${NLOHMANN_JSON_CMAKE_PROJECT_TARGETS_FILE}
    )
    install(
        TARGETS ${NLOHMANN_JSON_TARGET_NAME}
        EXPORT ${NLOHMANN_JSON_TARGETS_EXPORT_NAME}
        INCLUDES DESTINATION ${NLOHMANN_JSON_INCLUDE_INSTALL_DIR}
    )
    install(
        EXPORT ${NLOHMANN_JSON_TARGETS_EXPORT_NAME}
        NAMESPACE ${PROJECT_NAME}::
        DESTINATION ${NLOHMANN_JSON_CONFIG_INSTALL_DIR}
    )
endif()

=== debian/changelog ===
nlohmann-json3 (3.6.1-1) unstable; urgency=medium

  * Upload to unstable.
  * debian/control: add VCS info

 -- Hubert Chathi <uhoreg@debian.org>  Fri, 05 Jul 2019 12:15:55 -0400

nlohmann-json3 (3.6.1-0.1~exp1) experimental; urgency=medium

  * New upstream release
    - Upload to experimental due to freeze
  * Update copyright file and years

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Apr 2019 19:11:27 +0200

=== debian/control ===
Source: nlohmann-json3
Priority: optional
Maintainer: Hubert Chathi <uhoreg@debian.org>
Build-Depends:
 debhelper-compat ( =12),
 doxygen,
 ghostscript,
 graphviz,
 texlive-binaries,
 texlive-latex-base,
Standards-Version: 4.3.0
Section: libs
Homepage: https://nlohmann.github.io/json/
Vcs-Git: https://salsa.debian.org/debian/nlohmann-json3.git
Vcs-Browser: https://salsa.debian.org/debian/nlohmann-json3

Package: nlohmann-json3-dev
Section: libdevel
Architecture: all
Depends:
 ${misc:Depends},
Conflicts:
 nlohmann-json-dev
Description: JSON for Modern C++
 JSON library with intuitive syntax, trivial integration and serious
 testing. Other aspects, as memory efficiency and speed were not so
 important. The library consists of a single source file json.hpp.

## nlohmann-json3 3.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 ## PROJECT
 ## name and version
 ##
-project(nlohmann_json VERSION 3.6.1 LANGUAGES CXX)
+project(nlohmann_json VERSION 3.7.0 LANGUAGES CXX)
 
 ##
 ## INCLUDE
@@ -22,10 +22,11 @@
 ##
 ## CONFIGURATION
 ##
+include(GNUInstallDirs)
+
 set(NLOHMANN_JSON_TARGET_NAME               ${PROJECT_NAME})
-set(NLOHMANN_JSON_CONFIG_INSTALL_DIR        "lib/cmake/${PROJECT_NAME}"
-  CACHE INTERNAL "")
-set(NLOHMANN_JSON_INCLUDE_INSTALL_DIR       "include")
+set(NLOHMANN_JSON_CONFIG_INSTALL_DIR        "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE INTERNAL "")
+set(NLOHMANN_JSON_INCLUDE_INSTALL_DIR       "${CMAKE_INSTALL_INCLUDEDIR}")
 set(NLOHMANN_JSON_TARGETS_EXPORT_NAME       "${PROJECT_NAME}Targets")
 set(NLOHMANN_JSON_CMAKE_CONFIG_TEMPLATE     "cmake/config.cmake.in")
 set(NLOHMANN_JSON_CMAKE_CONFIG_DIR          "${CMAKE_CURRENT_BINARY_DIR}")
@@ -47,7 +48,7 @@
 ##
 add_library(${NLOHMANN_JSON_TARGET_NAME} INTERFACE)
 add_library(${PROJECT_NAME}::${NLOHMANN_JSON_TARGET_NAME} ALIAS ${NLOHMANN_JSON_TARGET_NAME})
-if (${CMAKE_VERSION} VERSION_LESS "3.8.0") 
+if (${CMAKE_VERSION} VERSION_LESS "3.8.0")
     target_compile_features(${NLOHMANN_JSON_TARGET_NAME} INTERFACE cxx_range_for)
 else()
     target_compile_features(${NLOHMANN_JSON_TARGET_NAME} INTERFACE cxx_std_11)

=== test/cmake_add_subdirectory/project/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(DummyImport CXX)

set(JSON_BuildTests OFF CACHE INTERNAL "")
add_subdirectory(${nlohmann_json_source}
   ${CMAKE_CURRENT_BINARY_DIR}/nlohmann_json)

add_executable(with_namespace_target main.cpp)
target_link_libraries(with_namespace_target nlohmann_json::nlohmann_json)

add_executable(without_namespace_target main.cpp)
target_link_libraries(without_namespace_target nlohmann_json)

=== debian/changelog ===
nlohmann-json3 (3.7.0-2) unstable; urgency=medium

  * Mark as multi-arch: Foreign (thanks to Helmut Grohne) (Closes: #933593)
  * debian/patches/cmake_archindep: make cmake version config file arch-indep

 -- Hubert Chathi <uhoreg@debian.org>  Thu, 01 Aug 2019 15:03:56 -0400

nlohmann-json3 (3.7.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control, debian/rules: use cmake, so that it can be found by cmake

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 30 Jul 2019 19:39:51 -0400

=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Priority: optional
 Maintainer: Hubert Chathi <uhoreg@debian.org>
 Build-Depends:
+ cmake,
  debhelper-compat ( =12),
  doxygen,
  ghostscript,
@@ -17,6 +18,7 @@
 Package: nlohmann-json3-dev
 Section: libdevel
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends},
 Conflicts:

## nlohmann-json3 3.7.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 ## PROJECT
 ## name and version
 ##
-project(nlohmann_json VERSION 3.7.0 LANGUAGES CXX)
+project(nlohmann_json VERSION 3.7.3 LANGUAGES CXX)
 
 ##
 ## INCLUDE

=== Makefile ===
.PHONY: pretty clean ChangeLog.md release

##########################################################################
# configuration
##########################################################################

# directory to recent compiler binaries
COMPILER_DIR=/Users/niels/Documents/projects/compilers/local/bin

# find GNU sed to use `-i` parameter
SED:=$(shell command -v gsed || which sed)


##########################################################################
# source files
##########################################################################

# the list of sources in the include folder
SRCS=$(shell find include -type f | sort)

# the single header (amalgamated from the source files)
AMALGAMATED_FILE=single_include/nlohmann/json.hpp


##########################################################################
# documentation of the Makefile's targets
##########################################################################

# main target
all:
	@echo "amalgamate - amalgamate file single_include/nlohmann/json.hpp from the include/nlohmann sources"
	@echo "ChangeLog.md - generate ChangeLog file"
	@echo "check - compile and execute test suite"
	@echo "check-amalgamation - check whether sources have been amalgamated"
	@echo "check-fast - compile and execute test suite (skip long-running tests)"
	@echo "clean - remove built files"
	@echo "coverage - create coverage information with lcov"
	@echo "coverage-fast - create coverage information with fastcov"
	@echo "cppcheck - analyze code with cppcheck"
	@echo "cpplint - analyze code with cpplint"
	@echo "clang_tidy - analyze code with Clang-Tidy"
	@echo "clang_analyze - analyze code with Clang-Analyzer"
	@echo "doctest - compile example files and check their output"
	@echo "fuzz_testing - prepare fuzz testing of the JSON parser"
	@echo "fuzz_testing_bson - prepare fuzz testing of the BSON parser"
	@echo "fuzz_testing_cbor - prepare fuzz testing of the CBOR parser"
	@echo "fuzz_testing_msgpack - prepare fuzz testing of the MessagePack parser"
	@echo "fuzz_testing_ubjson - prepare fuzz testing of the UBJSON parser"
	@echo "json_unit - create single-file test executable"
	@echo "pedantic_clang - run Clang with maximal warning flags"
	@echo "pedantic_gcc - run GCC with maximal warning flags"
	@echo "pretty - beautify code with Artistic Style"
	@echo "run_benchmarks - build and run benchmarks"


##########################################################################
# unit tests
##########################################################################

# build unit tests
json_unit:
	@$(MAKE) json_unit -C test

# run unit tests
check:
	$(MAKE) check -C test

# run unit tests and skip expensive tests
check-fast:
	$(MAKE) check -C test TEST_PATTERN=""


##########################################################################
# coverage
##########################################################################

coverage:
	rm -fr build_coverage
	mkdir build_coverage
	cd build_coverage ; CXX=g++-8 cmake .. -GNinja -DJSON_Coverage=ON -DJSON_MultipleHeaders=ON
	cd build_coverage ; ninja
	cd build_coverage ; ctest -E '.*_default' -j10
	cd build_coverage ; ninja lcov_html
	open build_coverage/test/html/index.html

coverage-fast:
	rm -fr build_coverage
	mkdir build_coverage
	cd build_coverage ; CXX=g++-9 cmake .. -GNinja -DJSON_Coverage=ON -DJSON_MultipleHeaders=ON
	cd build_coverage ; ninja
	cd build_coverage ; ctest -E '.*_default' -j10
	cd build_coverage ; ninja fastcov_html
	open build_coverage/test/html/index.html

##########################################################################
# documentation tests
##########################################################################

# compile example files and check output
doctest:
	$(MAKE) check_output -C doc


##########################################################################
# warning detector
##########################################################################

# calling Clang with all warnings, except:
# -Wno-c++2a-compat: u8 literals will behave differently in C++20...
# -Wno-deprecated-declarations: the library deprecated some functions
# -Wno-documentation-unknown-command: code uses user-defined commands like @complexity
# -Wno-exit-time-destructors: warning in json code triggered by NLOHMANN_JSON_SERIALIZE_ENUM
# -Wno-float-equal: not all comparisons in the tests can be replaced by Approx
# -Wno-keyword-macro: unit-tests use "#define private public"
# -Wno-padded: padding is nothing to warn about
# -Wno-range-loop-analysis: items tests "for(const auto i...)"
# -Wno-switch-enum -Wno-covered-switch-default: pedantic/contradicting warnings about switches
# -Wno-weak-vtables: exception class is defined inline, but has virtual method
pedantic_clang:
	$(MAKE) json_unit CXX=c++ CXXFLAGS=" \
		-std=c++11 -Wno-c++98-compat -Wno-c++98-compat-pedantic \
		-Werror \
		-Weverything \
		-Wno-c++2a-compat \
		-Wno-deprecated-declarations \
		-Wno-documentation-unknown-command \
		-Wno-exit-time-destructors \
		-Wno-float-equal \
		-Wno-keyword-macro \
		-Wno-padded \
		-Wno-range-loop-analysis \
		-Wno-switch-enum -Wno-covered-switch-default \
		-Wno-weak-vtables"

# calling GCC with most warnings
pedantic_gcc:
	$(MAKE) json_unit CXX=/usr/local/bin/g++-9 CXXFLAGS=" \
		-std=c++11 \
		-Waddress \
		-Waddress-of-packed-member \
		-Waggressive-loop-optimizations \
		-Waligned-new=all \
		-Wall \
		-Walloc-zero \
		-Walloca \
		-Warray-bounds \
		-Warray-bounds=2 \
		-Wattribute-alias=2 \
		-Wattribute-warning \
		-Wattributes \
		-Wbool-compare \
		-Wbool-operation \
		-Wbuiltin-declaration-mismatch \
		-Wbuiltin-macro-redefined \
		-Wcannot-profile \
		-Wcast-align \
		-Wcast-function-type \
		-Wcast-qual \
		-Wcatch-value=3 \
		-Wchar-subscripts \
		-Wclass-conversion \
		-Wclass-memaccess \
		-Wclobbered \
		-Wcomment \
		-Wcomments \
		-Wconditionally-supported \
		-Wconversion \
		-Wconversion-null \
		-Wcoverage-mismatch \
		-Wcpp \
		-Wctor-dtor-privacy \
		-Wdangling-else \
		-Wdate-time \
		-Wdelete-incomplete \
		-Wdelete-non-virtual-dtor \
		-Wdeprecated \
		-Wdeprecated-copy \
		-Wdeprecated-copy-dtor \
		-Wdeprecated-declarations \
		-Wdisabled-optimization \
		-Wdiv-by-zero \
		-Wdouble-promotion \
		-Wduplicated-branches \
		-Wduplicated-cond \
		-Weffc++ \
		-Wempty-body \
		-Wendif-labels \
		-Wenum-compare \
		-Wexpansion-to-defined \
		-Werror \
		-Wextra \
		-Wextra-semi \
		-Wfloat-conversion \
		-Wformat \
		-Wformat-contains-nul \
		-Wformat-extra-args \
		-Wformat-nonliteral \
		-Wformat-overflow=2 \
		-Wformat-security \
		-Wformat-signedness \
		-Wformat-truncation=2 \
		-Wformat-y2k \
		-Wformat-zero-length \
		-Wformat=2 \
		-Wframe-address \
		-Wfree-nonheap-object \
		-Whsa \
		-Wif-not-aligned \
		-Wignored-attributes \
		-Wignored-qualifiers \
		-Wimplicit-fallthrough=5 \
		-Winherited-variadic-ctor \
		-Winit-list-lifetime \
		-Winit-self \
		-Winline \
		-Wint-in-bool-context \
		-Wint-to-pointer-cast \
		-Winvalid-memory-model \
		-Winvalid-offsetof \
		-Winvalid-pch \
		-Wliteral-suffix \
		-Wlogical-not-parentheses \
		-Wlogical-op \
		-Wlto-type-mismatch \
		-Wmain \
		-Wmaybe-uninitialized \
		-Wmemset-elt-size \
		-Wmemset-transposed-args \
		-Wmisleading-indentation \
		-Wmissing-attributes \
		-Wmissing-braces \
		-Wmissing-declarations \
		-Wmissing-field-initializers \
		-Wmissing-format-attribute \
		-Wmissing-include-dirs \
		-Wmissing-noreturn \
		-Wmissing-profile \
		-Wmultichar \
		-Wmultiple-inheritance \
		-Wmultistatement-macros \
		-Wnarrowing \
		-Wno-deprecated-declarations \
		-Wno-float-equal \
		-Wno-long-long \
		-Wno-namespaces \
		-Wno-padded \
		-Wno-switch-enum \
		-Wno-system-headers \
		-Wno-templates \
		-Wno-undef \
		-Wnoexcept \
		-Wnoexcept-type \
		-Wnon-template-friend \
		-Wnon-virtual-dtor \
		-Wnonnull \
		-Wnonnull-compare \
		-Wnonportable-cfstrings \
		-Wnormalized \
		-Wnull-dereference \
		-Wodr \
		-Wold-style-cast \
		-Wopenmp-simd \
		-Woverflow \
		-Woverlength-strings \
		-Woverloaded-virtual \
		-Wpacked \
		-Wpacked-bitfield-compat \
		-Wpacked-not-aligned \
		-Wparentheses \
		-Wpedantic \
		-Wpessimizing-move \
		-Wplacement-new=2 \
		-Wpmf-conversions \
		-Wpointer-arith \
		-Wpointer-compare \
		-Wpragmas \
		-Wprio-ctor-dtor \
		-Wpsabi \
		-Wredundant-decls \
		-Wredundant-move \
		-Wregister \
		-Wreorder \
		-Wrestrict \
		-Wreturn-local-addr \
		-Wreturn-type \
		-Wscalar-storage-order \
		-Wsequence-point \
		-Wshadow \
		-Wshadow-compatible-local \
		-Wshadow-local \
		-Wshadow=compatible-local \
		-Wshadow=global \
		-Wshadow=local \
		-Wshift-count-negative \
		-Wshift-count-overflow \
		-Wshift-negative-value \
		-Wshift-overflow=2 \
		-Wsign-compare \
		-Wsign-conversion \
		-Wsign-promo \
		-Wsized-deallocation \
		-Wsizeof-array-argument \
		-Wsizeof-pointer-div \
		-Wsizeof-pointer-memaccess \
		-Wstack-protector \
		-Wstrict-aliasing=3 \
		-Wstrict-null-sentinel \
		-Wstrict-overflow=5 \
		-Wstringop-overflow=4 \
		-Wstringop-truncation \
		-Wsubobject-linkage \
		-Wsuggest-attribute=cold \
		-Wsuggest-attribute=const \
		-Wsuggest-attribute=format \
		-Wsuggest-attribute=malloc \
		-Wsuggest-attribute=noreturn \
		-Wsuggest-attribute=pure \
		-Wsuggest-final-methods \
		-Wsuggest-final-types \
		-Wsuggest-override \
		-Wswitch \
		-Wswitch-bool \
		-Wswitch-default \
		-Wswitch-unreachable \
		-Wsync-nand \
		-Wsynth \
		-Wtautological-compare \
		-Wterminate \
		-Wtrampolines \
		-Wtrigraphs \
		-Wtype-limits \
		-Wuninitialized \
		-Wunknown-pragmas \
		-Wunreachable-code \
		-Wunsafe-loop-optimizations \
		-Wunused \
		-Wunused-but-set-parameter \
		-Wunused-but-set-variable \
		-Wunused-const-variable=2 \
		-Wunused-function \
		-Wunused-label \
		-Wunused-local-typedefs \
		-Wunused-macros \
		-Wunused-parameter \
		-Wunused-result \
		-Wunused-value \
		-Wunused-variable \
		-Wuseless-cast \
		-Wvarargs \
		-Wvariadic-macros \
		-Wvector-operation-performance \
		-Wvirtual-inheritance \
		-Wvirtual-move-assign \
		-Wvla \
		-Wvolatile-register-var \
		-Wwrite-strings \
		-Wzero-as-null-pointer-constant \
		"

##########################################################################
# benchmarks
##########################################################################

run_benchmarks:
	rm -fr build_benchmarks
	mkdir build_benchmarks
	cd build_benchmarks ; cmake ../benchmarks -GNinja -DCMAKE_BUILD_TYPE=Release
	cd build_benchmarks ; ninja
	cd build_benchmarks ; ./json_benchmarks

##########################################################################
# fuzzing
##########################################################################

# the overall fuzz testing target
fuzz_testing:
	rm -fr fuzz-testing
	mkdir -p fuzz-testing fuzz-testing/testcases fuzz-testing/out
	$(MAKE) parse_afl_fuzzer -C test CXX=afl-clang++
	mv test/parse_afl_fuzzer fuzz-testing/fuzzer
	find test/data/json_tests -size -5k -name *json | xargs -I{} cp "{}" fuzz-testing/testcases
	@echo "Execute: afl-fuzz -i fuzz-testing/testcases -o fuzz-testing/out fuzz-testing/fuzzer"

fuzz_testing_bson:
	rm -fr fuzz-testing
	mkdir -p fuzz-testing fuzz-testing/testcases fuzz-testing/out
	$(MAKE) parse_bson_fuzzer -C test CXX=afl-clang++
	mv test/parse_bson_fuzzer fuzz-testing/fuzzer
	find test/data -size -5k -name *.bson | xargs -I{} cp "{}" fuzz-testing/testcases
	@echo "Execute: afl-fuzz -i fuzz-testing/testcases -o fuzz-testing/out fuzz-testing/fuzzer"

fuzz_testing_cbor:
	rm -fr fuzz-testing
	mkdir -p fuzz-testing fuzz-testing/testcases fuzz-testing/out
	$(MAKE) parse_cbor_fuzzer -C test CXX=afl-clang++
	mv test/parse_cbor_fuzzer fuzz-testing/fuzzer
	find test/data -size -5k -name *.cbor | xargs -I{} cp "{}" fuzz-testing/testcases
	@echo "Execute: afl-fuzz -i fuzz-testing/testcases -o fuzz-testing/out fuzz-testing/fuzzer"

fuzz_testing_msgpack:
	rm -fr fuzz-testing
	mkdir -p fuzz-testing fuzz-testing/testcases fuzz-testing/out
	$(MAKE) parse_msgpack_fuzzer -C test CXX=afl-clang++

=== test/cmake_import/CMakeLists.txt ===
add_test(NAME cmake_import_configure
  COMMAND ${CMAKE_COMMAND}
    -G "${CMAKE_GENERATOR}"
    -A "${CMAKE_GENERATOR_PLATFORM}"
    -Dnlohmann_json_DIR=${PROJECT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/project
)
add_test(NAME cmake_import_build
  COMMAND ${CMAKE_COMMAND} --build .
)
set_tests_properties(cmake_import_configure PROPERTIES
  FIXTURES_SETUP cmake_import
)
set_tests_properties(cmake_import_build PROPERTIES
  FIXTURES_REQUIRED cmake_import
)

=== debian/changelog ===
nlohmann-json3 (3.7.3-1) unstable; urgency=medium

  * Team upload (salsa.d.o namespace)
    - not committing the new tarball on git
  * New upstream version 3.7.3
  * Bump std-version to 4.5.0, no changes required

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 05 Feb 2020 22:38:47 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  graphviz,
  texlive-binaries,
  texlive-latex-base,
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Section: libs
 Homepage: https://nlohmann.github.io/json/
 Vcs-Git: https://salsa.debian.org/debian/nlohmann-json3.git

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


%:
	dh $@ --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean --buildsystem=cmake
	make -C doc clean
	rm -f -r doc/xml

override_dh_auto_configure:
	dh_auto_configure -- -DNLOHMANN_JSON_INCLUDE_INSTALL_DIR=include/nlohmann -DJSON_MultipleHeaders=ON -DNLOHMANN_JSON_CONFIG_INSTALL_DIR=lib/cmake/nlohmann_json

override_dh_auto_build:
	dh_auto_build --buildsystem=cmake
	make -C doc
	rm -f doc/html/*.md5
	rm -f doc/html/jquery.js
